cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};

cbuffer CONSTANT : register(b2)
{
	float4 fc32;
};


struct PixelInput
{
	float4 Position : SV_POSITION;
	float4 diff_color : COLOR0;
	float4 spec_color : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float fogc : FOG;
	float4 tc9 : TEXCOORD9;
	float4 tc0 : TEXCOORD0;
	float4 tc1 : TEXCOORD1;
	float4 tc2 : TEXCOORD2;
	float4 tc3 : TEXCOORD3;
	float4 tc4 : TEXCOORD4;
	float4 tc5 : TEXCOORD5;
	float4 tc6 : TEXCOORD6;
	float4 tc7 : TEXCOORD7;
	float4 tc8 : TEXCOORD8;
};

struct PixelOutput
{
	float4 ocol0 : SV_TARGET0;
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

void ps_impl(bool is_front_face, PixelInput In, inout float4 r0, inout float4 h0, inout float4 r1, inout float4 h2, inout float4 r2, inout float4 h4, inout float4 r3, inout float4 h6, inout float4 r4, inout float4 h8)
{
	float4 gl_FragCoord = In.Position;
	gl_FragCoord.y = (1080 - gl_FragCoord.y);
	r0 = fc32;

}

PixelOutput main(PixelInput In, bool is_front_face : SV_IsFrontFace)
{
	float4 r0 = float4(0., 0., 0., 0.);
	float4 r1 = float4(0., 0., 0., 0.);
	float4 r2 = float4(0., 0., 0., 0.);
	float4 r3 = float4(0., 0., 0., 0.);
	float4 r4 = float4(0., 0., 0., 0.);
	float4 h0 = float4(0., 0., 0., 0.);
	float4 h2 = float4(0., 0., 0., 0.);
	float4 h4 = float4(0., 0., 0., 0.);
	float4 h6 = float4(0., 0., 0., 0.);
	float4 h8 = float4(0., 0., 0., 0.);
	ps_impl(is_front_face, In, r0, h0, r1, h2, r2, h4, r3, h6, r4, h8);
	PixelOutput Out = (PixelOutput)0;
	Out.ocol0 = r0;
	return Out;
}
